/**
 * Compute a hailstone sequence.
 * @param n  starting number for sequence.  Assumes n > 0.
 * @returns hailstone sequence starting with n and ending with 1.
 */
function hailstoneSequence(n:number):Array<number> {
    let array:Array<number> = [];
    while (n !== 1) {
        array.push(n);
        if (n % 2 === 0) {
            n = n / 2;
        } else {
            n = 3 * n + 1;
        }
    }
    array.push(n);
    console.log(maxOfArray(array));
    return array;
}

/**
 * @param array must be nonempty
 * @returns maximum value of array
 */
function maxOfArray(array:Array<number>):number {
    let max = Number.NEGATIVE_INFINITY;
    for (const n of array) {
        max = Math.max(max, n);
    }
    return max;
}

console.log("hailstoneSequence(5)=", hailstoneSequence(5));
